### *** This class provides Binary Compatibility only, not Source Compatibility ***

Package com.sas.services.discovery

# Class IdAttribute

java.lang.Object
com.sas.services.AbstractServiceAttribute
com.sas.services.discovery.IdAttribute

All Implemented Interfaces:
  `ServiceAttributeInterface`, `Serializable`

Direct Known Subclasses:
  `JVMAttribute`

@SASScope("ALL") @BinaryCompatibilityOnly public class IdAttribute extends AbstractServiceAttribute
A foundation service discovery attribute representing an ID and ID type.

This attribute may be subclassed to create an attribute which can initialize the idType attribute to a well-known constant value.

Since:
  1.0
See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `String`
  `id`
  An ID associated with a service.
  `String`
  `idType`
  An additional attribute that may be used in the event that multiple IdAttribute objects are being used to represent different ids.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `IdAttribute()`
  Constructs a default instance with a `null` ID and `null` ID type.
  `IdAttribute(String attributeID)`
  Constructs an instance initialized with the specified ID.
  `IdAttribute(String attributeID, String attributeIDType)`
  Constructs an instance initialized with the specified ID and ID type.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Map<String,String>`
  `getFieldNameToValueMap()`
  Gets a map of this attribute's fields and their values.

  ### Methods inherited from class com.sas.services.AbstractServiceAttribute

  `equals, hashCode, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### id

    public String id
    An ID associated with a service.

  - ### idType

    public String idType
    An additional attribute that may be used in the event that multiple IdAttribute objects are being used to represent different ids.

- ## Constructor Details

  - ### IdAttribute

    public IdAttribute()
    Constructs a default instance with a `null` ID and `null` ID type.

  - ### IdAttribute

    public IdAttribute(String attributeID)
    Constructs an instance initialized with the specified ID.
    Parameters:
      `attributeID` - An ID associated with a service.

  - ### IdAttribute

    public IdAttribute(String attributeID, String attributeIDType)
    Constructs an instance initialized with the specified ID and ID type. The ID type may be used in the event that multiple IDs are associated with an object. For example, if we had a metadata `ServiceComponent` we could use "ServiceComponent" as the type.
    Parameters:
      `attributeID` - An ID associated with a service.
      `attributeIDType` - An additional type qualifier to help to distinguish what this ID represents.

- ## Method Details

  - ### getFieldNameToValueMap

    public Map<String,String> getFieldNameToValueMap()
    Gets a map of this attribute's fields and their values.
    - id - identifier
    - idType - identifier's type
    Overrides:
      `getFieldNameToValueMap` in class `AbstractServiceAttribute`
    Returns:
      Map keyed by the `String` names of a field to their values.